#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_color4  Green
#property indicator_color5  Green 
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2 
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property strict

//
//
//
//
//

enum maMethod
{
   ma_sma,  // Simple moving average
   ma_ema,  // Exponential moving average
   ma_smma, // Smoothed moving average
   ma_lwma, // Linear weighted moving average
   ma_vwma  // Volume weighted moving average
};

extern ENUM_TIMEFRAMES    TimeFrame            = PERIOD_CURRENT;  // Time frame
extern int                BandsLength          = 20;              // Bands period
extern double             BandsDeviation       = 2.0;             // Bands deviation
extern ENUM_APPLIED_PRICE AppliedPrice         = PRICE_CLOSE;     // Price
extern maMethod           AppliedMaMethod      = ma_sma;          // Average method
extern bool               alertsOn             = false;            // Trun alerts on?
extern bool               alertsOnCurrent      = false;           // Alerts on current bar?
extern bool               alertsOnBBreak       = true;            // Alerts on bands break?
extern bool               alertsOnSlope        = true;            // Alerts on slope change?
extern bool               alertsOnPriceCrossMa = true;            // Alerts on price crossing average?
extern bool               alertsMessage        = true;            // Alerts should display message?
extern bool               alertsSound          = false;           // Alerts should play a sound?
extern bool               alertsEmail          = false;           // Alerts should send an email?
extern bool               alertsPush           = false;           // Alerts should send push notification?
extern bool               Interpolate          = true;            // Interpolate in multi time frame mode?

//
//
//
//
//

double ma[],maDa[],maDb[],upBand[],dnBand[];
double trend[],slope[],trends[];

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,ma);
   SetIndexBuffer(1,maDa);
   SetIndexBuffer(2,maDb);
   SetIndexBuffer(3,upBand);
   SetIndexBuffer(4,dnBand);
   SetIndexBuffer(5,trend);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,trends);

    //
    //
    //
    //
    //
   
    indicatorFileName = WindowExpertName();
    returnBars        = TimeFrame==-99;
    TimeFrame         = MathMax(TimeFrame,_Period);
    IndicatorShortName(timeFrameToString(TimeFrame)+" better bollinger bands ");    
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-1,Bars-counted_bars);
         if (returnBars)  { ma[0] = limit+1; return(0); }
         
   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
      double alpha =  2.0/(BandsLength+1.0);
      if (slope[limit]==-1) CleanPoint(limit,maDa,maDb);  
      for (int i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double dt,dt2;
         if (AppliedMaMethod<ma_vwma)
         {
            dt  = iMA(NULL,0,BandsLength,0,(int)AppliedMaMethod,AppliedPrice,i);
            dt2 = iStdDev(NULL,0,BandsLength,0,(int)AppliedMaMethod,AppliedPrice,i);
         }
         else
         {
            dt2 = iStdDev(NULL,0,BandsLength,0,MODE_SMA,AppliedPrice,i);
            dt  = iMA(NULL,0,1,0,MODE_SMA,AppliedPrice,i)*Volume[i];
            double vt = (double)Volume[i];
            for (int k = 1; k<BandsLength && i+k<Bars; k++) { dt += iMA(NULL,0,1,0,MODE_SMA,AppliedPrice,i+k)*Volume[i+k]; vt += (double)Volume[i+k]; }
                  dt /= vt;
         }            
         
         ma[i]     = dt;
         upBand[i] = dt+BandsDeviation*dt2;
         dnBand[i] = dt-BandsDeviation*dt2;
         maDa[i]   = EMPTY_VALUE;
         maDb[i]   = EMPTY_VALUE;
         if (i<(Bars-1))
         {
            slope[i]  = slope[i+1];
            trend[i]  = trend[i+1];
            trends[i] = trends[i+1];

            if (ma[i] < ma[i+1])     slope[i]  = -1;
            if (ma[i] > ma[i+1])     slope[i]  =  1;
            if (High[i] > upBand[i]) trend[i]  = -1;
            if (Low[i]  < dnBand[i]) trend[i]  =  1;
            if (Close[i] < ma[i+1])  trends[i] = -1;
            if (Close[i] > ma[i+1])  trends[i] =  1;
         }            
         if (slope[i] == -1) PlotPoint(i,maDa,maDb,ma);
      }
      manageAlerts();
      return(0);            
   }
   
   //
   //
   //
   //
   //
      
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
   if (slope[limit]==-1) CleanPoint(limit,maDa,maDb);
   for(int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         ma[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BandsLength,BandsDeviation,AppliedPrice,AppliedMaMethod,alertsOn,alertsOnCurrent,alertsOnBBreak,alertsOnSlope,alertsOnPriceCrossMa,alertsMessage,alertsSound,alertsEmail,alertsPush,0,y);
         upBand[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BandsLength,BandsDeviation,AppliedPrice,AppliedMaMethod,alertsOn,alertsOnCurrent,alertsOnBBreak,alertsOnSlope,alertsOnPriceCrossMa,alertsMessage,alertsSound,alertsEmail,alertsPush,3,y);
         dnBand[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BandsLength,BandsDeviation,AppliedPrice,AppliedMaMethod,alertsOn,alertsOnCurrent,alertsOnBBreak,alertsOnSlope,alertsOnPriceCrossMa,alertsMessage,alertsSound,alertsEmail,alertsPush,4,y);
         slope[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BandsLength,BandsDeviation,AppliedPrice,AppliedMaMethod,alertsOn,alertsOnCurrent,alertsOnBBreak,alertsOnSlope,alertsOnPriceCrossMa,alertsMessage,alertsSound,alertsEmail,alertsPush,6,y);
         maDa[i]   = EMPTY_VALUE;
         maDb[i]   = EMPTY_VALUE;
         if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
         //
         //
         //
         //
         //
                  
         int n,j; datetime time = iTime(NULL,TimeFrame,y);
            for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
            for(j = 1; j<n && (i+n)<Bars && (i+j)<Bars; j++)
            {
               upBand[i+j] = upBand[i] + (upBand[i+n] - upBand[i])*j/n;
               dnBand[i+j] = dnBand[i] + (dnBand[i+n] - dnBand[i])*j/n;
               ma[i+j]     = ma[i]     + (ma[i+n]     - ma[i]    )*j/n;
            }                              
   }
   for (int i=limit;i>=0;i--) if (slope[i]==-1) PlotPoint(i,maDa,maDb,ma);
   return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnBBreak && trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1) doAlert(time1,mess1,whichBar," low price closed below lower band ");
            if (trend[whichBar] == -1) doAlert(time1,mess1,whichBar," high price closed above upper band ");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] ==  1) doAlert(time2,mess2,whichBar," bands ma sloping up ");
            if (slope[whichBar] == -1) doAlert(time2,mess2,whichBar," bands ma sloping down ");
         } 
      static datetime time3 = 0;
      static string   mess3 = "";
         if (alertsOnPriceCrossMa && trends[whichBar] != trends[whichBar+1])
         {
            if (trends[whichBar] ==  1) doAlert(time3,mess3,whichBar," price crossed center ma up ");
            if (trends[whichBar] == -1) doAlert(time3,mess3,whichBar," price crossed center ma down ");
         }                       
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" "+timeFrameToString(_Period)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Bollinger Band "),message);
             if (alertsPush)    SendNotification(message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


